 REM QUICKBASIC program to display clock time and phase

REM CLOCK0.BAS

REM Software is Copyright (C) Murray Greenman ZL1BPU 2001

REM Expects a frame of 16 bytes, "HH:MM:SS :PPPP<CR><LF>"
REM HHMMSS is the UTC time; PPPP is the reference phase
REM Frames are received at 1 sec intervals, and terminated by CR/LF.

declarations:
	pno$ = "2"      'set the com port
	sample% = 1    'secs between graph samples
	ts = 1          'sample count

start:
	CLS
	PRINT "ZL1BPU SUPERCLOCK                 Phase Comparator       Connect Clock to COM"; pno$; ""
	KEY OFF
	OPEN "com" + pno$ + ":9600,N,8,1,cs0,ds0" FOR RANDOM AS #1
	ON ERROR GOTO allerr
	LINE INPUT #1, reg$   'throw away first reading

main:
	z$ = INKEY$
	IF z$ = CHR$(27) THEN
		END
	END IF
	LINE INPUT #1, reg$
	IF LEFT$(reg$, 1) <> CHR$(10) THEN GOTO main    'dud data
	IF LEN(reg$) <> 14 THEN GOTO main
	reg$ = RIGHT$(reg$, LEN(reg$) - 1)'throw away LF at start of line
debug:
REM        fred$ = LEFT$(reg$ + SPACE$(32), 32)
REM        PRINT fred$

Clock:
	t$ = LEFT$(reg$, 8)
REM        LOCATE 2, 35: PRINT T$; " UTC";
       
endframe:
	phase$ = MID$(reg$, 10, 4)
	phase = VAL("&H" + phase$)
	ts = ts + 1
	IF ts > sample% THEN
		ts = 1:
		GOSUB drawphase
	END IF
	GOTO main



drawphase:
REM adjustable speed slow graph
	phaseh = (phase / 32) AND 63
	phasel = phase AND 63
	PRINT t$; " ";
	FOR st = 1 TO 64
	IF st = phaseh + 1 THEN
		PRINT "*";
	ELSE
		IF st = INT(phasel) + 1 THEN
			PRINT ".";
		ELSE
			PRINT " ";
		END IF
	END IF
	NEXT st
	PRINT " " + phase$
	RETURN



allerr:
	REM PRINT ERR, ERL
	RESUME NEXT
END


